# Komga API Client
Komga offers 2 APIs: REST and OPDS.

Both APIs are secured using HTTP Basic Authentication.

This Dart package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v37.0
- Build package: org.openapitools.codegen.languages.DartDioClientCodegen

## Requirements

Dart 1.20.0 or later OR Flutter 0.0.20 or later

## Installation & Usage

### Github
If this Dart package is published to Github, please include the following in pubspec.yaml
```
name: Komga API Client
version: 37
description: Generated dart package for interacting with Komga's API in Dart with Dio
dependencies:
  Komga API Client:
    git: https://github.com/frameset/komga_api_client.git
      version: 'any'
```

### Local
To use the package in your local drive, please include the following in pubspec.yaml
```
dependencies:
  Komga API Client:
    path: /path/to/Komga API Client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```dart
import 'package:Komga API Client/api.dart';


var api_instance = new BookControllerApi();
var bookId = 789; // int | 

try {
    api_instance.analyze(bookId);
} catch (e) {
    print("Exception when calling BookControllerApi->analyze: $e\n");
}

```

## Documentation for API Endpoints

All URIs are relative to *https://demo.komga.org*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*BookControllerApi* | [**analyze**](doc\/BookControllerApi.md#analyze) | **post** /api/v1/books/{bookId}/analyze | 
*BookControllerApi* | [**deleteReadProgress**](doc\/BookControllerApi.md#deletereadprogress) | **delete** /api/v1/books/{bookId}/read-progress | 
*BookControllerApi* | [**getAllBooks**](doc\/BookControllerApi.md#getallbooks) | **get** /api/v1/books | 
*BookControllerApi* | [**getBookFile**](doc\/BookControllerApi.md#getbookfile) | **get** /api/v1/books/{bookId}/file | 
*BookControllerApi* | [**getBookFile1**](doc\/BookControllerApi.md#getbookfile1) | **get** /api/v1/books/{bookId}/file/* | 
*BookControllerApi* | [**getBookPage**](doc\/BookControllerApi.md#getbookpage) | **get** /api/v1/books/{bookId}/pages/{pageNumber} | 
*BookControllerApi* | [**getBookPageThumbnail**](doc\/BookControllerApi.md#getbookpagethumbnail) | **get** /api/v1/books/{bookId}/pages/{pageNumber}/thumbnail | 
*BookControllerApi* | [**getBookPages**](doc\/BookControllerApi.md#getbookpages) | **get** /api/v1/books/{bookId}/pages | 
*BookControllerApi* | [**getBookSiblingNext**](doc\/BookControllerApi.md#getbooksiblingnext) | **get** /api/v1/books/{bookId}/next | 
*BookControllerApi* | [**getBookSiblingPrevious**](doc\/BookControllerApi.md#getbooksiblingprevious) | **get** /api/v1/books/{bookId}/previous | 
*BookControllerApi* | [**getBookThumbnail**](doc\/BookControllerApi.md#getbookthumbnail) | **get** /api/v1/books/{bookId}/thumbnail | 
*BookControllerApi* | [**getBooksOnDeck**](doc\/BookControllerApi.md#getbooksondeck) | **get** /api/v1/books/ondeck | 
*BookControllerApi* | [**getLatestBooks**](doc\/BookControllerApi.md#getlatestbooks) | **get** /api/v1/books/latest | 
*BookControllerApi* | [**getOneBook**](doc\/BookControllerApi.md#getonebook) | **get** /api/v1/books/{bookId} | 
*BookControllerApi* | [**markReadProgress**](doc\/BookControllerApi.md#markreadprogress) | **patch** /api/v1/books/{bookId}/read-progress | 
*BookControllerApi* | [**refreshMetadata**](doc\/BookControllerApi.md#refreshmetadata) | **post** /api/v1/books/{bookId}/metadata/refresh | 
*BookControllerApi* | [**updateMetadata**](doc\/BookControllerApi.md#updatemetadata) | **patch** /api/v1/books/{bookId}/metadata | 
*ClaimControllerApi* | [**claimAdmin**](doc\/ClaimControllerApi.md#claimadmin) | **post** /api/v1/claim | 
*FileSystemControllerApi* | [**getDirectoryListing**](doc\/FileSystemControllerApi.md#getdirectorylisting) | **post** /api/v1/filesystem | 
*LibraryControllerApi* | [**addOne**](doc\/LibraryControllerApi.md#addone) | **post** /api/v1/libraries | 
*LibraryControllerApi* | [**analyze1**](doc\/LibraryControllerApi.md#analyze1) | **post** /api/v1/libraries/{libraryId}/analyze | 
*LibraryControllerApi* | [**deleteOne**](doc\/LibraryControllerApi.md#deleteone) | **delete** /api/v1/libraries/{id} | 
*LibraryControllerApi* | [**getAll**](doc\/LibraryControllerApi.md#getall) | **get** /api/v1/libraries | 
*LibraryControllerApi* | [**getOne**](doc\/LibraryControllerApi.md#getone) | **get** /api/v1/libraries/{id} | 
*LibraryControllerApi* | [**refreshMetadata1**](doc\/LibraryControllerApi.md#refreshmetadata1) | **post** /api/v1/libraries/{libraryId}/metadata/refresh | 
*LibraryControllerApi* | [**scan**](doc\/LibraryControllerApi.md#scan) | **post** /api/v1/libraries/{libraryId}/scan | 
*ReferentialControllerApi* | [**getAuthors**](doc\/ReferentialControllerApi.md#getauthors) | **get** /api/v1/authors | 
*SeriesControllerApi* | [**analyze2**](doc\/SeriesControllerApi.md#analyze2) | **post** /api/v1/series/{seriesId}/analyze | 
*SeriesControllerApi* | [**getAllBooksBySeries**](doc\/SeriesControllerApi.md#getallbooksbyseries) | **get** /api/v1/series/{seriesId}/books | 
*SeriesControllerApi* | [**getAllSeries**](doc\/SeriesControllerApi.md#getallseries) | **get** /api/v1/series | 
*SeriesControllerApi* | [**getLatestSeries**](doc\/SeriesControllerApi.md#getlatestseries) | **get** /api/v1/series/latest | 
*SeriesControllerApi* | [**getNewSeries**](doc\/SeriesControllerApi.md#getnewseries) | **get** /api/v1/series/new | 
*SeriesControllerApi* | [**getOneSeries**](doc\/SeriesControllerApi.md#getoneseries) | **get** /api/v1/series/{seriesId} | 
*SeriesControllerApi* | [**getSeriesThumbnail**](doc\/SeriesControllerApi.md#getseriesthumbnail) | **get** /api/v1/series/{seriesId}/thumbnail | 
*SeriesControllerApi* | [**getUpdatedSeries**](doc\/SeriesControllerApi.md#getupdatedseries) | **get** /api/v1/series/updated | 
*SeriesControllerApi* | [**markAsRead**](doc\/SeriesControllerApi.md#markasread) | **post** /api/v1/series/{seriesId}/read-progress | 
*SeriesControllerApi* | [**markAsUnread**](doc\/SeriesControllerApi.md#markasunread) | **delete** /api/v1/series/{seriesId}/read-progress | 
*SeriesControllerApi* | [**refreshMetadata2**](doc\/SeriesControllerApi.md#refreshmetadata2) | **post** /api/v1/series/{seriesId}/metadata/refresh | 
*SeriesControllerApi* | [**updateMetadata1**](doc\/SeriesControllerApi.md#updatemetadata1) | **patch** /api/v1/series/{seriesId}/metadata | 
*UserControllerApi* | [**addOne1**](doc\/UserControllerApi.md#addone1) | **post** /api/v1/users | 
*UserControllerApi* | [**delete**](doc\/UserControllerApi.md#delete) | **delete** /api/v1/users/{id} | 
*UserControllerApi* | [**getAll1**](doc\/UserControllerApi.md#getall1) | **get** /api/v1/users | 
*UserControllerApi* | [**getMe**](doc\/UserControllerApi.md#getme) | **get** /api/v1/users/me | 
*UserControllerApi* | [**updatePassword**](doc\/UserControllerApi.md#updatepassword) | **patch** /api/v1/users/me/password | 
*UserControllerApi* | [**updateSharesLibraries**](doc\/UserControllerApi.md#updateshareslibraries) | **patch** /api/v1/users/{id}/shared-libraries | 
*UserControllerApi* | [**updateUserRoles**](doc\/UserControllerApi.md#updateuserroles) | **patch** /api/v1/users/{id} | 


## Documentation For Models

 - [AuthorDto](doc\/AuthorDto.md)
 - [AuthorUpdateDto](doc\/AuthorUpdateDto.md)
 - [BookDto](doc\/BookDto.md)
 - [BookMetadataDto](doc\/BookMetadataDto.md)
 - [BookMetadataUpdateDto](doc\/BookMetadataUpdateDto.md)
 - [DirectoryListingDto](doc\/DirectoryListingDto.md)
 - [DirectoryRequestDto](doc\/DirectoryRequestDto.md)
 - [LibraryCreationDto](doc\/LibraryCreationDto.md)
 - [LibraryDto](doc\/LibraryDto.md)
 - [MediaDto](doc\/MediaDto.md)
 - [PageBookDto](doc\/PageBookDto.md)
 - [PageDto](doc\/PageDto.md)
 - [PageSeriesDto](doc\/PageSeriesDto.md)
 - [Pageable](doc\/Pageable.md)
 - [PasswordUpdateDto](doc\/PasswordUpdateDto.md)
 - [PathDto](doc\/PathDto.md)
 - [ReadProgressDto](doc\/ReadProgressDto.md)
 - [ReadProgressUpdateDto](doc\/ReadProgressUpdateDto.md)
 - [RolesUpdateDto](doc\/RolesUpdateDto.md)
 - [SeriesDto](doc\/SeriesDto.md)
 - [SeriesMetadataDto](doc\/SeriesMetadataDto.md)
 - [SeriesMetadataUpdateDto](doc\/SeriesMetadataUpdateDto.md)
 - [SharedLibrariesUpdateDto](doc\/SharedLibrariesUpdateDto.md)
 - [SharedLibraryDto](doc\/SharedLibraryDto.md)
 - [Sort](doc\/Sort.md)
 - [UserCreationDto](doc\/UserCreationDto.md)
 - [UserDto](doc\/UserDto.md)
 - [UserWithSharedLibrariesDto](doc\/UserWithSharedLibrariesDto.md)


## Documentation For Authorization


## basicAuth

- **Type**: HTTP basic authentication


## Author




