# komga_api_client.api.BookControllerApi

## Load the API package
```dart
import 'package:komga_api_client/api.dart';
```

All URIs are relative to *https://demo.komga.org*

Method | HTTP request | Description
------------- | ------------- | -------------
[**analyze**](BookControllerApi.md#analyze) | **post** /api/v1/books/{bookId}/analyze | 
[**deleteReadProgress**](BookControllerApi.md#deleteReadProgress) | **delete** /api/v1/books/{bookId}/read-progress | 
[**getAllBooks**](BookControllerApi.md#getAllBooks) | **get** /api/v1/books | 
[**getBookFile**](BookControllerApi.md#getBookFile) | **get** /api/v1/books/{bookId}/file | 
[**getBookFile1**](BookControllerApi.md#getBookFile1) | **get** /api/v1/books/{bookId}/file/* | 
[**getBookPage**](BookControllerApi.md#getBookPage) | **get** /api/v1/books/{bookId}/pages/{pageNumber} | 
[**getBookPageThumbnail**](BookControllerApi.md#getBookPageThumbnail) | **get** /api/v1/books/{bookId}/pages/{pageNumber}/thumbnail | 
[**getBookPages**](BookControllerApi.md#getBookPages) | **get** /api/v1/books/{bookId}/pages | 
[**getBookSiblingNext**](BookControllerApi.md#getBookSiblingNext) | **get** /api/v1/books/{bookId}/next | 
[**getBookSiblingPrevious**](BookControllerApi.md#getBookSiblingPrevious) | **get** /api/v1/books/{bookId}/previous | 
[**getBookThumbnail**](BookControllerApi.md#getBookThumbnail) | **get** /api/v1/books/{bookId}/thumbnail | 
[**getBooksOnDeck**](BookControllerApi.md#getBooksOnDeck) | **get** /api/v1/books/ondeck | 
[**getLatestBooks**](BookControllerApi.md#getLatestBooks) | **get** /api/v1/books/latest | 
[**getOneBook**](BookControllerApi.md#getOneBook) | **get** /api/v1/books/{bookId} | 
[**markReadProgress**](BookControllerApi.md#markReadProgress) | **patch** /api/v1/books/{bookId}/read-progress | 
[**refreshMetadata**](BookControllerApi.md#refreshMetadata) | **post** /api/v1/books/{bookId}/metadata/refresh | 
[**updateMetadata**](BookControllerApi.md#updateMetadata) | **patch** /api/v1/books/{bookId}/metadata | 


# **analyze**
> analyze(bookId)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var bookId = 789; // int | 

try { 
    api_instance.analyze(bookId);
} catch (e) {
    print("Exception when calling BookControllerApi->analyze: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookId** | **int**|  | [default to null]

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **deleteReadProgress**
> deleteReadProgress(bookId)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var bookId = 789; // int | 

try { 
    api_instance.deleteReadProgress(bookId);
} catch (e) {
    print("Exception when calling BookControllerApi->deleteReadProgress: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookId** | **int**|  | [default to null]

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getAllBooks**
> PageBookDto getAllBooks(search, libraryId, mediaStatus, readStatus, page, size, sort)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var search = search_example; // String | 
var libraryId = []; // List<int> | 
var mediaStatus = []; // List<String> | 
var readStatus = []; // List<String> | 
var page = 56; // int | Zero-based page index (0..N)
var size = 56; // int | The size of the page to be returned
var sort = []; // List<String> | Sorting criteria in the format: property(,asc|desc). Default sort order is ascending. Multiple sort criteria are supported.

try { 
    var result = api_instance.getAllBooks(search, libraryId, mediaStatus, readStatus, page, size, sort);
    print(result);
} catch (e) {
    print("Exception when calling BookControllerApi->getAllBooks: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **search** | **String**|  | [optional] [default to null]
 **libraryId** | [**List&lt;int&gt;**](int.md)|  | [optional] [default to const []]
 **mediaStatus** | [**List&lt;String&gt;**](String.md)|  | [optional] [default to const []]
 **readStatus** | [**List&lt;String&gt;**](String.md)|  | [optional] [default to const []]
 **page** | **int**| Zero-based page index (0..N) | [optional] [default to null]
 **size** | **int**| The size of the page to be returned | [optional] [default to null]
 **sort** | [**List&lt;String&gt;**](String.md)| Sorting criteria in the format: property(,asc|desc). Default sort order is ascending. Multiple sort criteria are supported. | [optional] [default to const []]

### Return type

[**PageBookDto**](PageBookDto.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getBookFile**
> Uint8List getBookFile(bookId)



Download the book file.

### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var bookId = 789; // int | 

try { 
    var result = api_instance.getBookFile(bookId);
    print(result);
} catch (e) {
    print("Exception when calling BookControllerApi->getBookFile: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookId** | **int**|  | [default to null]

### Return type

[**Uint8List**](Uint8List.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/octet-stream

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getBookFile1**
> Uint8List getBookFile1(bookId)



Download the book file.

### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var bookId = 789; // int | 

try { 
    var result = api_instance.getBookFile1(bookId);
    print(result);
} catch (e) {
    print("Exception when calling BookControllerApi->getBookFile1: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookId** | **int**|  | [default to null]

### Return type

[**Uint8List**](Uint8List.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/octet-stream

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getBookPage**
> Uint8List getBookPage(bookId, pageNumber, convert, zeroBased)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var bookId = 789; // int | 
var pageNumber = 56; // int | 
var convert = convert_example; // String | Convert the image to the provided format.
var zeroBased = true; // bool | If set to true, pages will start at index 0. If set to false, pages will start at index 1.

try { 
    var result = api_instance.getBookPage(bookId, pageNumber, convert, zeroBased);
    print(result);
} catch (e) {
    print("Exception when calling BookControllerApi->getBookPage: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookId** | **int**|  | [default to null]
 **pageNumber** | **int**|  | [default to null]
 **convert** | **String**| Convert the image to the provided format. | [optional] [default to null]
 **zeroBased** | **bool**| If set to true, pages will start at index 0. If set to false, pages will start at index 1. | [optional] [default to false]

### Return type

[**Uint8List**](Uint8List.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: image/_*

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getBookPageThumbnail**
> Uint8List getBookPageThumbnail(bookId, pageNumber)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var bookId = 789; // int | 
var pageNumber = 56; // int | 

try { 
    var result = api_instance.getBookPageThumbnail(bookId, pageNumber);
    print(result);
} catch (e) {
    print("Exception when calling BookControllerApi->getBookPageThumbnail: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookId** | **int**|  | [default to null]
 **pageNumber** | **int**|  | [default to null]

### Return type

[**Uint8List**](Uint8List.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: image/jpeg

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getBookPages**
> List<PageDto> getBookPages(bookId)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var bookId = 789; // int | 

try { 
    var result = api_instance.getBookPages(bookId);
    print(result);
} catch (e) {
    print("Exception when calling BookControllerApi->getBookPages: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookId** | **int**|  | [default to null]

### Return type

[**List<PageDto>**](PageDto.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getBookSiblingNext**
> BookDto getBookSiblingNext(bookId)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var bookId = 789; // int | 

try { 
    var result = api_instance.getBookSiblingNext(bookId);
    print(result);
} catch (e) {
    print("Exception when calling BookControllerApi->getBookSiblingNext: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookId** | **int**|  | [default to null]

### Return type

[**BookDto**](BookDto.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getBookSiblingPrevious**
> BookDto getBookSiblingPrevious(bookId)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var bookId = 789; // int | 

try { 
    var result = api_instance.getBookSiblingPrevious(bookId);
    print(result);
} catch (e) {
    print("Exception when calling BookControllerApi->getBookSiblingPrevious: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookId** | **int**|  | [default to null]

### Return type

[**BookDto**](BookDto.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getBookThumbnail**
> Uint8List getBookThumbnail(bookId)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var bookId = 789; // int | 

try { 
    var result = api_instance.getBookThumbnail(bookId);
    print(result);
} catch (e) {
    print("Exception when calling BookControllerApi->getBookThumbnail: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookId** | **int**|  | [default to null]

### Return type

[**Uint8List**](Uint8List.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: image/jpeg

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getBooksOnDeck**
> PageBookDto getBooksOnDeck(page, size)



Return first unread book of series with at least one book read and no books in progress.

### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var page = 56; // int | Zero-based page index (0..N)
var size = 56; // int | The size of the page to be returned

try { 
    var result = api_instance.getBooksOnDeck(page, size);
    print(result);
} catch (e) {
    print("Exception when calling BookControllerApi->getBooksOnDeck: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **page** | **int**| Zero-based page index (0..N) | [optional] [default to null]
 **size** | **int**| The size of the page to be returned | [optional] [default to null]

### Return type

[**PageBookDto**](PageBookDto.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getLatestBooks**
> PageBookDto getLatestBooks(page, size)



Return newly added or updated books.

### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var page = 56; // int | Zero-based page index (0..N)
var size = 56; // int | The size of the page to be returned

try { 
    var result = api_instance.getLatestBooks(page, size);
    print(result);
} catch (e) {
    print("Exception when calling BookControllerApi->getLatestBooks: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **page** | **int**| Zero-based page index (0..N) | [optional] [default to null]
 **size** | **int**| The size of the page to be returned | [optional] [default to null]

### Return type

[**PageBookDto**](PageBookDto.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **getOneBook**
> BookDto getOneBook(bookId)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var bookId = 789; // int | 

try { 
    var result = api_instance.getOneBook(bookId);
    print(result);
} catch (e) {
    print("Exception when calling BookControllerApi->getOneBook: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookId** | **int**|  | [default to null]

### Return type

[**BookDto**](BookDto.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **markReadProgress**
> markReadProgress(bookId, readProgressUpdateDto)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var bookId = 789; // int | 
var readProgressUpdateDto = new ReadProgressUpdateDto(); // ReadProgressUpdateDto | page can be omitted if completed is set to true. completed can be omitted, and will be set accordingly depending on the page passed and the total number of pages in the book.

try { 
    api_instance.markReadProgress(bookId, readProgressUpdateDto);
} catch (e) {
    print("Exception when calling BookControllerApi->markReadProgress: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookId** | **int**|  | [default to null]
 **readProgressUpdateDto** | [**ReadProgressUpdateDto**](ReadProgressUpdateDto.md)| page can be omitted if completed is set to true. completed can be omitted, and will be set accordingly depending on the page passed and the total number of pages in the book. | 

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **refreshMetadata**
> refreshMetadata(bookId)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var bookId = 789; // int | 

try { 
    api_instance.refreshMetadata(bookId);
} catch (e) {
    print("Exception when calling BookControllerApi->refreshMetadata: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookId** | **int**|  | [default to null]

### Return type

void (empty response body)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: Not defined

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **updateMetadata**
> BookDto updateMetadata(bookId, bookMetadataUpdateDto)



### Example 
```dart
import 'package:komga_api_client/api.dart';

var api_instance = new BookControllerApi();
var bookId = 789; // int | 
var bookMetadataUpdateDto = new BookMetadataUpdateDto(); // BookMetadataUpdateDto | Metadata fields to update. Set a field to null to unset the metadata. You can omit fields you don't want to update.

try { 
    var result = api_instance.updateMetadata(bookId, bookMetadataUpdateDto);
    print(result);
} catch (e) {
    print("Exception when calling BookControllerApi->updateMetadata: $e\n");
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **bookId** | **int**|  | [default to null]
 **bookMetadataUpdateDto** | [**BookMetadataUpdateDto**](BookMetadataUpdateDto.md)| Metadata fields to update. Set a field to null to unset the metadata. You can omit fields you don&#39;t want to update. | 

### Return type

[**BookDto**](BookDto.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

