import 'dart:async';
import 'dart:io';
import 'dart:convert';
import 'package:dio/dio.dart';
import 'package:built_collection/built_collection.dart';
import 'package:built_value/serializer.dart';

import 'package:komga_api_client/model/user_dto.dart';

class ClaimControllerApi {
    final Dio _dio;
    Serializers _serializers;

    ClaimControllerApi(this._dio, this._serializers);

        /// 
        ///
        /// 
        Future<Response<UserDto>>claimAdmin(String xKomgaEmail,String xKomgaPassword,{ CancelToken cancelToken, Map<String, String> headers,}) async {

        String _path = "/api/v1/claim";

        Map<String, dynamic> queryParams = {};
        Map<String, String> headerParams = Map.from(headers ?? {});
        dynamic bodyData;

                headerParams[r'X-Komga-Email'] = xKomgaEmail;
                headerParams[r'X-Komga-Password'] = xKomgaPassword;
        queryParams.removeWhere((key, value) => value == null);
        headerParams.removeWhere((key, value) => value == null);

        List<String> contentTypes = [];



            return _dio.request(
            _path,
            queryParameters: queryParams,
            data: bodyData,
            options: Options(
            method: 'post'.toUpperCase(),
            headers: headerParams,
            extra: {
                'secure': [],
            },
            contentType: contentTypes.isNotEmpty ? contentTypes[0] : "application/json",
            ),
            cancelToken: cancelToken,
            ).then((response) {

        var serializer = _serializers.serializerForType(UserDto);
        var data = _serializers.deserializeWith<UserDto>(serializer, response.data is String ? jsonDecode(response.data) : response.data);

            return Response<UserDto>(
                data: data,
                headers: response.headers,
                request: response.request,
                redirects: response.redirects,
                statusCode: response.statusCode,
                statusMessage: response.statusMessage,
                extra: response.extra,
            );
            });
            }
        }
