import 'dart:async';
import 'dart:io';
import 'dart:convert';
import 'package:dio/dio.dart';
import 'package:built_collection/built_collection.dart';
import 'package:built_value/serializer.dart';

import 'package:komga_api_client/model/directory_request_dto.dart';
import 'package:komga_api_client/model/directory_listing_dto.dart';

class FileSystemControllerApi {
    final Dio _dio;
    Serializers _serializers;

    FileSystemControllerApi(this._dio, this._serializers);

        /// 
        ///
        /// 
        Future<Response<DirectoryListingDto>>getDirectoryListing(DirectoryRequestDto directoryRequestDto,{ CancelToken cancelToken, Map<String, String> headers,}) async {

        String _path = "/api/v1/filesystem";

        Map<String, dynamic> queryParams = {};
        Map<String, String> headerParams = Map.from(headers ?? {});
        dynamic bodyData;

        queryParams.removeWhere((key, value) => value == null);
        headerParams.removeWhere((key, value) => value == null);

        List<String> contentTypes = ["application/json"];


            var serializedBody = _serializers.serialize(directoryRequestDto);
            var jsondirectoryRequestDto = json.encode(serializedBody);
            bodyData = jsondirectoryRequestDto;

            return _dio.request(
            _path,
            queryParameters: queryParams,
            data: bodyData,
            options: Options(
            method: 'post'.toUpperCase(),
            headers: headerParams,
            extra: {
                'secure': [],
            },
            contentType: contentTypes.isNotEmpty ? contentTypes[0] : "application/json",
            ),
            cancelToken: cancelToken,
            ).then((response) {

        var serializer = _serializers.serializerForType(DirectoryListingDto);
        var data = _serializers.deserializeWith<DirectoryListingDto>(serializer, response.data is String ? jsonDecode(response.data) : response.data);

            return Response<DirectoryListingDto>(
                data: data,
                headers: response.headers,
                request: response.request,
                redirects: response.redirects,
                statusCode: response.statusCode,
                statusMessage: response.statusMessage,
                extra: response.extra,
            );
            });
            }
        }
