            import 'package:komga_api_client/model/read_progress_dto.dart';
            import 'package:komga_api_client/model/media_dto.dart';
            import 'package:time_machine/time_machine.dart';
            import 'package:komga_api_client/model/book_metadata_dto.dart';
        import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'book_dto.g.dart';

abstract class BookDto implements Built<BookDto, BookDtoBuilder> {

    
        @nullable
    @BuiltValueField(wireName: r'id')
    int get id;
    
        @nullable
    @BuiltValueField(wireName: r'seriesId')
    int get seriesId;
    
        @nullable
    @BuiltValueField(wireName: r'libraryId')
    int get libraryId;
    
        @nullable
    @BuiltValueField(wireName: r'name')
    String get name;
    
        @nullable
    @BuiltValueField(wireName: r'url')
    String get url;
    
        @nullable
    @BuiltValueField(wireName: r'number')
    int get number;
    
        @nullable
    @BuiltValueField(wireName: r'created')
    OffsetDateTime get created;
    
        @nullable
    @BuiltValueField(wireName: r'lastModified')
    OffsetDateTime get lastModified;
    
        @nullable
    @BuiltValueField(wireName: r'fileLastModified')
    OffsetDateTime get fileLastModified;
    
        @nullable
    @BuiltValueField(wireName: r'sizeBytes')
    int get sizeBytes;
    
        @nullable
    @BuiltValueField(wireName: r'size')
    String get size;
    
        @nullable
    @BuiltValueField(wireName: r'media')
    MediaDto get media;
    
        @nullable
    @BuiltValueField(wireName: r'metadata')
    BookMetadataDto get metadata;
    
        @nullable
    @BuiltValueField(wireName: r'readProgress')
    ReadProgressDto get readProgress;

    // Boilerplate code needed to wire-up generated code
    BookDto._();

    factory BookDto([updates(BookDtoBuilder b)]) = _$BookDto;
    static Serializer<BookDto> get serializer => _$bookDtoSerializer;

}

