            import 'package:built_collection/built_collection.dart';
            import 'package:komga_api_client/model/author_dto.dart';
            import 'package:time_machine/time_machine.dart';
        import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'book_metadata_dto.g.dart';

abstract class BookMetadataDto implements Built<BookMetadataDto, BookMetadataDtoBuilder> {

    
        @nullable
    @BuiltValueField(wireName: r'title')
    String get title;
    
        @nullable
    @BuiltValueField(wireName: r'titleLock')
    bool get titleLock;
    
        @nullable
    @BuiltValueField(wireName: r'summary')
    String get summary;
    
        @nullable
    @BuiltValueField(wireName: r'summaryLock')
    bool get summaryLock;
    
        @nullable
    @BuiltValueField(wireName: r'number')
    String get number;
    
        @nullable
    @BuiltValueField(wireName: r'numberLock')
    bool get numberLock;
    
        @nullable
    @BuiltValueField(wireName: r'numberSort')
    double get numberSort;
    
        @nullable
    @BuiltValueField(wireName: r'numberSortLock')
    bool get numberSortLock;
    
        @nullable
    @BuiltValueField(wireName: r'readingDirection')
    String get readingDirection;
    
        @nullable
    @BuiltValueField(wireName: r'readingDirectionLock')
    bool get readingDirectionLock;
    
        @nullable
    @BuiltValueField(wireName: r'publisher')
    String get publisher;
    
        @nullable
    @BuiltValueField(wireName: r'publisherLock')
    bool get publisherLock;
    
        @nullable
    @BuiltValueField(wireName: r'ageRating')
    int get ageRating;
    
        @nullable
    @BuiltValueField(wireName: r'ageRatingLock')
    bool get ageRatingLock;
    
        @nullable
    @BuiltValueField(wireName: r'releaseDate')
    OffsetDate get releaseDate;
    
        @nullable
    @BuiltValueField(wireName: r'releaseDateLock')
    bool get releaseDateLock;
    
        @nullable
    @BuiltValueField(wireName: r'authors')
    BuiltList<AuthorDto> get authors;
    
        @nullable
    @BuiltValueField(wireName: r'authorsLock')
    bool get authorsLock;

    // Boilerplate code needed to wire-up generated code
    BookMetadataDto._();

    factory BookMetadataDto([updates(BookMetadataDtoBuilder b)]) = _$BookMetadataDto;
    static Serializer<BookMetadataDto> get serializer => _$bookMetadataDtoSerializer;

}

