            import 'package:komga_api_client/model/author_update_dto.dart';
            import 'package:built_collection/built_collection.dart';
            import 'package:time_machine/time_machine.dart';
        import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'book_metadata_update_dto.g.dart';

abstract class BookMetadataUpdateDto implements Built<BookMetadataUpdateDto, BookMetadataUpdateDtoBuilder> {

    
        @nullable
    @BuiltValueField(wireName: r'title')
    String get title;
    
        @nullable
    @BuiltValueField(wireName: r'titleLock')
    bool get titleLock;
    
        @nullable
    @BuiltValueField(wireName: r'summary')
    String get summary;
    
        @nullable
    @BuiltValueField(wireName: r'summaryLock')
    bool get summaryLock;
    
        @nullable
    @BuiltValueField(wireName: r'number')
    String get number;
    
        @nullable
    @BuiltValueField(wireName: r'numberLock')
    bool get numberLock;
    
        @nullable
    @BuiltValueField(wireName: r'numberSort')
    double get numberSort;
    
        @nullable
    @BuiltValueField(wireName: r'numberSortLock')
    bool get numberSortLock;
    
        @nullable
    @BuiltValueField(wireName: r'readingDirectionLock')
    bool get readingDirectionLock;
    
        @nullable
    @BuiltValueField(wireName: r'publisher')
    String get publisher;
    
        @nullable
    @BuiltValueField(wireName: r'publisherLock')
    bool get publisherLock;
    
        @nullable
    @BuiltValueField(wireName: r'ageRatingLock')
    bool get ageRatingLock;
    
        @nullable
    @BuiltValueField(wireName: r'releaseDateLock')
    bool get releaseDateLock;
    
        @nullable
    @BuiltValueField(wireName: r'authorsLock')
    bool get authorsLock;
    
        @nullable
    @BuiltValueField(wireName: r'readingDirection')
    String get readingDirection;
        //enum readingDirectionEnum {  LEFT_TO_RIGHT,  RIGHT_TO_LEFT,  VERTICAL,  WEBTOON,  };
    
        @nullable
    @BuiltValueField(wireName: r'releaseDate')
    OffsetDate get releaseDate;
    
        @nullable
    @BuiltValueField(wireName: r'ageRating')
    int get ageRating;
    
        @nullable
    @BuiltValueField(wireName: r'authors')
    BuiltList<AuthorUpdateDto> get authors;

    // Boilerplate code needed to wire-up generated code
    BookMetadataUpdateDto._();

    factory BookMetadataUpdateDto([updates(BookMetadataUpdateDtoBuilder b)]) = _$BookMetadataUpdateDto;
    static Serializer<BookMetadataUpdateDto> get serializer => _$bookMetadataUpdateDtoSerializer;

}

