            import 'package:komga_api_client/model/pageable.dart';
            import 'package:komga_api_client/model/sort.dart';
            import 'package:built_collection/built_collection.dart';
            import 'package:komga_api_client/model/book_dto.dart';
        import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'page_book_dto.g.dart';

abstract class PageBookDto implements Built<PageBookDto, PageBookDtoBuilder> {

    
        @nullable
    @BuiltValueField(wireName: r'totalPages')
    int get totalPages;
    
        @nullable
    @BuiltValueField(wireName: r'totalElements')
    int get totalElements;
    
        @nullable
    @BuiltValueField(wireName: r'first')
    bool get first;
    
        @nullable
    @BuiltValueField(wireName: r'sort')
    Sort get sort;
    
        @nullable
    @BuiltValueField(wireName: r'numberOfElements')
    int get numberOfElements;
    
        @nullable
    @BuiltValueField(wireName: r'pageable')
    Pageable get pageable;
    
        @nullable
    @BuiltValueField(wireName: r'last')
    bool get last;
    
        @nullable
    @BuiltValueField(wireName: r'size')
    int get size;
    
        @nullable
    @BuiltValueField(wireName: r'content')
    BuiltList<BookDto> get content;
    
        @nullable
    @BuiltValueField(wireName: r'number')
    int get number;
    
        @nullable
    @BuiltValueField(wireName: r'empty')
    bool get empty;

    // Boilerplate code needed to wire-up generated code
    PageBookDto._();

    factory PageBookDto([updates(PageBookDtoBuilder b)]) = _$PageBookDto;
    static Serializer<PageBookDto> get serializer => _$pageBookDtoSerializer;

}

