            import 'package:komga_api_client/model/series_dto.dart';
            import 'package:komga_api_client/model/pageable.dart';
            import 'package:komga_api_client/model/sort.dart';
            import 'package:built_collection/built_collection.dart';
        import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'page_series_dto.g.dart';

abstract class PageSeriesDto implements Built<PageSeriesDto, PageSeriesDtoBuilder> {

    
        @nullable
    @BuiltValueField(wireName: r'totalPages')
    int get totalPages;
    
        @nullable
    @BuiltValueField(wireName: r'totalElements')
    int get totalElements;
    
        @nullable
    @BuiltValueField(wireName: r'first')
    bool get first;
    
        @nullable
    @BuiltValueField(wireName: r'sort')
    Sort get sort;
    
        @nullable
    @BuiltValueField(wireName: r'numberOfElements')
    int get numberOfElements;
    
        @nullable
    @BuiltValueField(wireName: r'pageable')
    Pageable get pageable;
    
        @nullable
    @BuiltValueField(wireName: r'last')
    bool get last;
    
        @nullable
    @BuiltValueField(wireName: r'size')
    int get size;
    
        @nullable
    @BuiltValueField(wireName: r'content')
    BuiltList<SeriesDto> get content;
    
        @nullable
    @BuiltValueField(wireName: r'number')
    int get number;
    
        @nullable
    @BuiltValueField(wireName: r'empty')
    bool get empty;

    // Boilerplate code needed to wire-up generated code
    PageSeriesDto._();

    factory PageSeriesDto([updates(PageSeriesDtoBuilder b)]) = _$PageSeriesDto;
    static Serializer<PageSeriesDto> get serializer => _$pageSeriesDtoSerializer;

}

