            import 'package:komga_api_client/model/series_metadata_dto.dart';
            import 'package:time_machine/time_machine.dart';
        import 'package:built_value/built_value.dart';
import 'package:built_value/serializer.dart';

part 'series_dto.g.dart';

abstract class SeriesDto implements Built<SeriesDto, SeriesDtoBuilder> {

    
        @nullable
    @BuiltValueField(wireName: r'id')
    int get id;
    
        @nullable
    @BuiltValueField(wireName: r'libraryId')
    int get libraryId;
    
        @nullable
    @BuiltValueField(wireName: r'name')
    String get name;
    
        @nullable
    @BuiltValueField(wireName: r'url')
    String get url;
    
        @nullable
    @BuiltValueField(wireName: r'created')
    OffsetDateTime get created;
    
        @nullable
    @BuiltValueField(wireName: r'lastModified')
    OffsetDateTime get lastModified;
    
        @nullable
    @BuiltValueField(wireName: r'fileLastModified')
    OffsetDateTime get fileLastModified;
    
        @nullable
    @BuiltValueField(wireName: r'booksCount')
    int get booksCount;
    
        @nullable
    @BuiltValueField(wireName: r'booksReadCount')
    int get booksReadCount;
    
        @nullable
    @BuiltValueField(wireName: r'booksUnreadCount')
    int get booksUnreadCount;
    
        @nullable
    @BuiltValueField(wireName: r'booksInProgressCount')
    int get booksInProgressCount;
    
        @nullable
    @BuiltValueField(wireName: r'metadata')
    SeriesMetadataDto get metadata;

    // Boilerplate code needed to wire-up generated code
    SeriesDto._();

    factory SeriesDto([updates(SeriesDtoBuilder b)]) = _$SeriesDto;
    static Serializer<SeriesDto> get serializer => _$seriesDtoSerializer;

}

