library serializers;

import 'package:built_value/iso_8601_date_time_serializer.dart';
import 'package:built_value/serializer.dart';
import 'package:built_collection/built_collection.dart';
import 'package:built_value/json_object.dart';
import 'package:built_value/standard_json_plugin.dart';
import 'package:time_machine/time_machine.dart';
import 'package:komga_api_client/local_date_serializer.dart';
import 'package:komga_api_client/model/author_dto.dart';
import 'package:komga_api_client/model/author_update_dto.dart';
import 'package:komga_api_client/model/book_dto.dart';
import 'package:komga_api_client/model/book_metadata_dto.dart';
import 'package:komga_api_client/model/book_metadata_update_dto.dart';
import 'package:komga_api_client/model/directory_listing_dto.dart';
import 'package:komga_api_client/model/directory_request_dto.dart';
import 'package:komga_api_client/model/library_creation_dto.dart';
import 'package:komga_api_client/model/library_dto.dart';
import 'package:komga_api_client/model/media_dto.dart';
import 'package:komga_api_client/model/page_book_dto.dart';
import 'package:komga_api_client/model/page_dto.dart';
import 'package:komga_api_client/model/page_series_dto.dart';
import 'package:komga_api_client/model/pageable.dart';
import 'package:komga_api_client/model/password_update_dto.dart';
import 'package:komga_api_client/model/path_dto.dart';
import 'package:komga_api_client/model/read_progress_dto.dart';
import 'package:komga_api_client/model/read_progress_update_dto.dart';
import 'package:komga_api_client/model/roles_update_dto.dart';
import 'package:komga_api_client/model/series_dto.dart';
import 'package:komga_api_client/model/series_metadata_dto.dart';
import 'package:komga_api_client/model/series_metadata_update_dto.dart';
import 'package:komga_api_client/model/shared_libraries_update_dto.dart';
import 'package:komga_api_client/model/shared_library_dto.dart';
import 'package:komga_api_client/model/sort.dart';
import 'package:komga_api_client/model/user_creation_dto.dart';
import 'package:komga_api_client/model/user_dto.dart';
import 'package:komga_api_client/model/user_with_shared_libraries_dto.dart';


part 'serializers.g.dart';

@SerializersFor(const [
AuthorDto,
AuthorUpdateDto,
BookDto,
BookMetadataDto,
BookMetadataUpdateDto,
DirectoryListingDto,
DirectoryRequestDto,
LibraryCreationDto,
LibraryDto,
MediaDto,
PageBookDto,
PageDto,
PageSeriesDto,
Pageable,
PasswordUpdateDto,
PathDto,
ReadProgressDto,
ReadProgressUpdateDto,
RolesUpdateDto,
SeriesDto,
SeriesMetadataDto,
SeriesMetadataUpdateDto,
SharedLibrariesUpdateDto,
SharedLibraryDto,
Sort,
UserCreationDto,
UserDto,
UserWithSharedLibrariesDto,

])

//allow all models to be serialized within a list
Serializers serializers = (_$serializers.toBuilder()
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(AuthorDto)]),
() => new ListBuilder<AuthorDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(AuthorUpdateDto)]),
() => new ListBuilder<AuthorUpdateDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(BookDto)]),
() => new ListBuilder<BookDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(BookMetadataDto)]),
() => new ListBuilder<BookMetadataDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(BookMetadataUpdateDto)]),
() => new ListBuilder<BookMetadataUpdateDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(DirectoryListingDto)]),
() => new ListBuilder<DirectoryListingDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(DirectoryRequestDto)]),
() => new ListBuilder<DirectoryRequestDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(LibraryCreationDto)]),
() => new ListBuilder<LibraryCreationDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(LibraryDto)]),
() => new ListBuilder<LibraryDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(MediaDto)]),
() => new ListBuilder<MediaDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(PageBookDto)]),
() => new ListBuilder<PageBookDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(PageDto)]),
() => new ListBuilder<PageDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(PageSeriesDto)]),
() => new ListBuilder<PageSeriesDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(Pageable)]),
() => new ListBuilder<Pageable>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(PasswordUpdateDto)]),
() => new ListBuilder<PasswordUpdateDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(PathDto)]),
() => new ListBuilder<PathDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(ReadProgressDto)]),
() => new ListBuilder<ReadProgressDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(ReadProgressUpdateDto)]),
() => new ListBuilder<ReadProgressUpdateDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(RolesUpdateDto)]),
() => new ListBuilder<RolesUpdateDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(SeriesDto)]),
() => new ListBuilder<SeriesDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(SeriesMetadataDto)]),
() => new ListBuilder<SeriesMetadataDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(SeriesMetadataUpdateDto)]),
() => new ListBuilder<SeriesMetadataUpdateDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(SharedLibrariesUpdateDto)]),
() => new ListBuilder<SharedLibrariesUpdateDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(SharedLibraryDto)]),
() => new ListBuilder<SharedLibraryDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(Sort)]),
() => new ListBuilder<Sort>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(UserCreationDto)]),
() => new ListBuilder<UserCreationDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(UserDto)]),
() => new ListBuilder<UserDto>())
..addBuilderFactory(
const FullType(BuiltList, const [const FullType(UserWithSharedLibrariesDto)]),
() => new ListBuilder<UserWithSharedLibrariesDto>())

..add(Iso8601DateTimeSerializer())
).build();

Serializers standardSerializers =
(serializers.toBuilder()
..add(OffsetDateSerializer())
..add(OffsetDateTimeSerializer())
..addPlugin(StandardJsonPlugin())).build();
